/******************************************************************************
 JXExprEditorSet.h

	Interface for the JXExprEditorSet class

	Copyright  1996 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_JXExprEditorSet
#define _H_JXExprEditorSet

#include <JXWidgetSet.h>
#include <JXMenu.h>			// need definition of JXMenu::Style

class JVariableList;
class JXMenuBar;
class JXExprEditor;

class JXExprEditorSet : public JXWidgetSet
{
public:

	JXExprEditorSet(const JVariableList* varList, const JXMenu::Style menuStyle,
					JXExprEditor** exprWidget, JXContainer* enclosure,
					const HSizingOption hSizing, const VSizingOption vSizing,
					const JCoordinate x, const JCoordinate y,
					const JCoordinate w, const JCoordinate h);

	JXExprEditorSet(const JVariableList* varList, JXMenuBar* menuBar,
					const JXMenu::Style menuStyle,
					JXExprEditor** exprWidget, JXContainer* enclosure,
					const HSizingOption hSizing, const VSizingOption vSizing,
					const JCoordinate x, const JCoordinate y,
					const JCoordinate w, const JCoordinate h);

	JXExprEditorSet(const JVariableList* varList, JXExprEditor* menuProvider,
					JXExprEditor** exprWidget, JXContainer* enclosure,
					const HSizingOption hSizing, const VSizingOption vSizing,
					const JCoordinate x, const JCoordinate y,
					const JCoordinate w, const JCoordinate h);

	virtual ~JXExprEditorSet();

private:

	// not allowed

	JXExprEditorSet(const JXExprEditorSet& source);
	const JXExprEditorSet& operator=(const JXExprEditorSet& source);
};

#endif
